#include <stdio.h>
#include <string.h>
#include <ctype.h>

/* 02/12/90 -- hu:
 * New utility function for make to process a macro assignment string.
 * Uses standard C string/ctype functions so it is not machine dependent.
 * Called by input() and main().
*/
void
assign_macro (s)
char *s;	/* s must be pre-checked for the presence of '=' */
{
	char *name, *val;
	register char *p, *q;
	char svp, svq;
	int  use_empty = 0;

	/* bypass leading space */
	while (isspace (*s)) s++;
	name = s;

	/* find the = char */
	p = strchr (s, '=');
	if (p == name) return;
	val = p + 1;

	if (*(p-1) == '\\') {
	  if ((p - 1) == name) return;
	  p--;
	}
	p--;
	while (isspace(*p)) p--;
	p++;
	svp = *p;
	*p = '\0';

	/* now check the value part, we just need to see if null string */
	q = val;
	while (*q != '\0'  &&  isspace(*q)) q++;
	if (*q == '\0') use_empty = 1;
	else {
	  val = q;
	  q = val + strlen(val) - 1;
	  if (isspace(*q)) while (isspace(*q)) q--;
	  q++;
	  svq = *q;
	  *q = '\0';
	}

	if (use_empty) setmacro (name, " ");
	else setmacro (name, val);

	/* restore original chars that we replaced with null */
	*p = svp;
	if (use_empty == 0) *q = svq;
}
